#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform sampler2DRect maskTex;
uniform float transitionProgress=1.0;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor;

in vec2 fsTexture;
in vec2 fsTextureSize;
in vec2 fsMaskTexture;
in vec2 fsTextureNormalized;
in float fsABSelect;

out vec4 outColor;


void main()
{
    float x1 = transitionProgressLinear;
    vec2 p1 = fsTextureNormalized;
	
	x1=smoothstep(.20,.80,(x1*2.0+p1.x-1.0));

	vec2 tc1=(p1-.5)*(1.-x1)+.5;
	
    tc1=(p1-.5)*x1+.5;
//	tc2=(p2-.5)*x2+.5;
	
	vec4 texColor=texture(inputTex,tc1*fsTextureSize);
	vec4 colorA=mix(vec4(0,0,0,0),texColor,fsABSelect);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),fsABSelect);

	outColor=mix(colorB,colorA,transitionProgressLinear);
//    outColor=texture(inputTex,tc*fsTextureSize)*fsMix;
//    gl_FragColor = mix(texture2D(from, (p-.5)*(1.-x)+.5), texture2D(to, (p-.5)*x+.5), progress);
#ifdef USE_MASK
	outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}
